# Inplemented requirements in WebSocketUpgrade.md
These tables keep track of which requirements are implemented.

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 3.1-1       | Yes          | MUST     |
| 3.1-2       | Yes          | MUST     |
| 3.1-3       | Yes          | MAY      |
| 3.1-4       | Yes          | MUST     |
| 3.1-5       |              | MUST NOT |
| 3.1-6       | Inapplicable | MUST     |
| 3.1-7       |              | SHOULD   |
| 3.1-8       |              | MUST     |
| 3.1-9       | Inapplicable |          |
| 3.1-10      | Inapplicable | MUST NOT |
| 3.1-11      | Inapplicable | MUST     |
| 3.1-12      | Inapplicable | MUST     |
| 3.1-13      | Inapplicable | MAY      |
| 3.1-14      | Inapplicable | MUST NOT |
| 3.1-15      | Inapplicable | MUST     |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 3.2-1       | In progress  |          | RFC 2396 should be a source for further requirements.
| 3.2-2       |              |          |
| 3.2-3       | Inapplicable | MUST     |
| 3.2-4       | Inapplicable | SHOULD   |
| 3.2-5       | Inapplicable |          |
| 3.2-6       |              |          |
| 3.2-7       | Implemented  |          |
| 3.2-8       |              |          |
| 3.2-9       | Inapplicable | SHOULD   |
| 3.2-10      |              |          |
| 3.2-11      | Inapplicable |          |
| 3.2-12      | Inapplicable |          |
| 3.2-13      |              | SHOULD   |
| 3.2-14      |              | SHOULD   |
| 3.2-15      |              |          |
| 3.2-16      |              |          |
| 3.2-17      |              |          |
| 3.2-18      |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 3.3-1       |              |          |
| 3.3-2       |              | MUST     |
| 3.3-3       |              | MUST     |
| 3.3-4       |              | MUST     |
| 3.3-5       |              | MUST     |
| 3.3-6       |              | MUST NOT |
| 3.3-7       |              |          |
| 3.3-8       |              |          |
| 3.3-9       |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 3.4-1       |              |          |
| 3.4-2       |              | MUST     |
| 3.4-3       |              |          |
| 3.4-4       |              |          |
| 3.4-5       |              | MUST     |
| 3.4-6       |              | SHOULD   |
| 3.4-7       |              | MAY      |
| 3.4-8       |              | SHOULD   |
| 3.4-9       |              | MUST     |
| 3.4-10      |              | MUST     |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 3.8-1       |              |          |
| 3.8-2       |              | SHOULD   |
| 3.8-3       |              | MUST NOT |
| 3.8-4       |              | MAY      |
| 3.8-5       |              | SHOULD   |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 4.1-1       |              |          |
| 4.1-2       | In progress  |          | Depends on chapter 5.1 and 6.1.
| 4.1-3       |              | SHOULD   |
| 4.1-4       |              | MUST NOT |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 4.2-1       |              |          |
| 4.2-2       |              |          |
| 4.2-3       |              | MAY      |
| 4.2-4       |              |          |
| 4.2-5       |              |          |
| 4.2-6       | In progress  |          |
| 4.2-7       |              | MAY      |
| 4.2-8       |              | MAY      |
| 4.2-9       |              |          |
| 4.2-10      |              | MAY      |
| 4.2-11      |              | MUST     |
| 4.2-12      |              | MUST NOT |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 4.4-1       |              |          |
| 4.4-2       |              |          |
| 4.4-3       |              |          |
| 4.4-4       |              | MUST NOT |
| 4.4-5       |              | MUST     |
| 4.4-6       |              |          |
| 4.4-7       |              |          |
| 4.4-8       |              | MUST     |
| 4.4-9       |              | SHOULD   |
| 4.4-10      |              | MUST     |
| 4.4-11      |              | MUST NOT |
| 4.4-12      |              | MUST     |
| 4.4-13      |              | MUST     |
| 4.4-14      |              | MUST     |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 4.5-1       |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 5-1         |              |          |
| 5.1-1       |              |          |
| 5.1-2       |              |          |
| 5.1-3       |              |          |
| 5.1-4       |              | SHOULD   |
| 5.1-5       |              | MUST     |
| 5.1-6       |              | MUST     |
| 5.1-7       |              |          |
| 5.1-8       |              |          |
| 5.1-9       |              |          |
| 5.1-10      |              | MAY      |
| 5.1-11      |              | MUST     |
| 5.1-12      |              | MUST     |
| 5.1-13      |              |          |
| 5.1-14      |              | MUST     |
| 5.1-15      |              | MUST     |
| 5.1-16      |              |          |
| 5.1-17      |              | MUST     |
| 5.1-18      |              |          |
| 5.1-19      |              | MUST     |
| 5.1-20      |              | SHOULD   |
| 5.1-21      |              | MUST NOT |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 5.2-1       |              | MAY      |
| 5.2-2       |              | MUST     |
| 5.2-3       |              |          |
| 5.2-4       |              |          |
| 5.2-5       |              | MUST     |
| 5.2-6       |              | MAY      |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 5.3-1       |              |          |
| 5.3-2       |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 6-1         |              |          |
| 6.1-1       | In progress  |          |
| 6.1-2       | In progress  |          |
| 6.1-3       | In progress  |          |
| 6.1-4       |              |          |
| 6.1-5       |              |          |
| 6.1-6       |              | MUST     |
| 6.1-7       |              | MUST NOT |
| 6.1-8       |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 6.2-1       | In progress  |          |
| 6.2-2       |              |          |
| 6.2-3       |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 10.1-1      |              |          |
| 10.1-2      |              |          |
| 10.1-3      |              |          |
| 10.1-4      |              |          |
| 10.1-5      |              |          |
| 10.1-6      |              |          |
| 10.1.1-1    |              |          |
| 10.1.1-2    |              |          |
| 10.1.1-3    |              |          |
| 10.1.2-1    |              |          |
| 10.1.2-2    |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 14.10-1     |              |          |
| 14.10-2     |              |          |
| 14.10-3     |              |          |
| 14.10-4     |              |          |
| 14.10-5     |              |          |
| 14.10-6     |              |          |
| 14.10-7     |              |          |
| 14.10-8     |              |          |
| 14.10-9     |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 14.18-1     |              |          |
| 14.18-2     |              |          |
| 14.18-3     |              |          |
| 14.18-4     |              |          |
| 14.18-5     |              |          |
| 14.18-6     |              |          |
| 14.18-7     |              |          |
| 14.18-8     |              |          |
| 14.18-9     |              |          |
| 14.18-10    |              |          |
| 14.18-11    |              |          |
| 14.18-12    |              |          |
| 14.18-13    |              |          |
| 14.18-14    |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 14.23-1     |              |          |
| 14.23-2     |              |          |
| 14.23-3     |              |          |
| 14.23-4     |              |          |
| 14.23-5     |              |          |
| 14.23-6     |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 14.38-1     |              |          |
| 14.38-2     |              |          |
| 14.38-3     |              |          |
| 14.38-4     |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 14.42-1     | Inapplicable |          | Server side requirement.
| 14.42-2     |              |          |
| 14.42-3     | Inapplicable |          | The WebSocket protocol will fail if the upgrade is not accepted by the server.
| 14.42-4     | Inapplicable |          | Server side requirement.
| 14.42-5     | In progress  |          |
| 14.42-6     | Inapplicable |          | The "websocket" protocol name is defined in the WebSocket protocol.

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 14.43-1     |              |          |
| 14.43-2     |              |          |
| 14.43-3     |              |          |
| 14.43-4     |              |          |

| Requirement | Implemented  | Keyword  | Comment
| ----------- | ------------ | -------- | -------
| 15.3-1      |              |          |
| 15.3-2      |              |          |
| 15.3-3      |              |          |
